<?php

  class mw_users_albums extends mw_controller{

    public $user;
    public $status;
    public $album_status_id;

    public function validate(){
      $env = $this->env();
      $data = $env->data();
      if(($this->status = $data->source_status()) === false){
        return "Impossible de lire la liste des status de source";
      }
      foreach($this->status as $id_source_status => $source_status){
        if($source_status["nom"] == "album"){
          $this->album_status_id = $id_source_status;
          break;
        }
      }
      if(!isset($this->album_status_id)){
        return "Type de source inconnu: album";
      }
      if(!($this->user = $env->user())){
        return "Vous devez être identifié pour accéder à cette page";
      }
      return true;
    }

    public function index(){
      $env = $this->env();
      $data = $env->data();
      if(($groupes = $data->groupes($this->user["id"])) === false){
        $env->erreur("Impossible de lire la liste des groupes");
        return;
      }
      $id_groupe = false;
      if(isset($_GET[$env->param("groupe")])){
        $id_groupe = $_GET[$env->param("groupe")];
        if(!isset($groupes["list"][$id_groupe])){
          $env->erreur("Impossible de lire les informations du groupe");
          return;
        }
      }
      $select = array(
        "status" => $this->album_status_id,
        "id_user" => $this->user["id"],
        "order_by" => "ordre",
        "start" => isset($_GET[$env->param("start")]) && $_GET[$env->param("start")] ? $_GET[$env->param("start")] : 0
      );
      if($id_groupe) $select["id_groupe"] = $id_groupe;
      if(($albums = $data->sources($select)) === false){
        $env->erreur("impossible de lire la liste des albums");
        return;
      }
      foreach($albums["list"] as $id_album => $album){
        $albums["list"][$id_album]["permissions"] = $data->source_permissions($album, $this->user["id"]);
      }
      if($_POST){
        foreach($albums["list"] as $id_album => $album){
          if(isset($_POST["ordre_".$id_album])){
            if($data->set_source_info($album["id"], "ordre", $_POST["ordre_".$id_album]) === false){
              $env->erreur("Impossible d'enregistrer l'ordre des albums");
              return;
            }
          }
        }
        $get_params = array();
        if($id_groupe) $get_params["groupe"] = $id_groupe;
        $env->redirect(
          $env->url("users/albums", $get_params),
          "l'ordre des albums a été enregistré"
        );
      }
      $env->set_out("groupes", $groupes);
      $env->set_out("albums", $albums);
    }

    public function add(){
      $env = $this->env();
      $data = $env->data();
      $album = $data->empty_source();
      $source_infos = array(
        "date_inscription" => date("Y-m-d"),
        "ordre" => 0
      );
      $groupe = false;
      if(($groupes = $data->groupes($this->user["id"])) === false){
        $env->erreur("Impossible de lire la liste des groupes");
        return;
      }
      if(($licences = $data->licences()) === false){
        return "Impossible de lire la liste des licences";
      }
      if(!$data->check_user_uploads_dir()){
        $env->erreur("Impossible de creer le repertoire utilisateur");
        return;
      }
      $web_path = $env->path("web");
      $upload_dir = $env->path("content")."uploads/".$this->user["id"];
      $_SESSION["upload_dir"] = $web_path.($web_path ? "" : "/").$env->path("content")."uploads/".$this->user["id"];
      $users_sources_mod = $env->get_controller("users/sources");
      if($_POST){
        if(!($groupe = $data->groupe($_POST["id_groupe"]))){
          $env->erreur("Impossible de lire les informations du groupe");
          return;
        }
        $groupe["id_groupe_status"] = $data->id_groupe_status_admin();
        $album["groupes"] = array($groupe["id"] => $groupe);
        if(!($album["titre"] = trim($_POST["titre"]))){
          $env->message("merci de pr&eacute;ciser un titre pour l'album");
        }
        $album["licence"] = array(
          "id" => $_POST["licence"]
        );
        $source_infos["date_creation"] = $_POST["annee_date_creation"]."-".$_POST["mois_date_creation"]."-".$_POST["jour_date_creation"];
        $source_infos["description"] = $_POST["description"];
        foreach($_POST as $post_key => $post_value){
          if(substr($post_key, 0, 13) == "document_nom_"){
            if($id_document = substr($post_key, 13)){
              $album["documents"][$id_document] = array(
                "nom" => $_POST["document_nom_".$id_document],
                "url" => $_POST["document_url_".$id_document]
              );
            }
          }
        }
        if(!$env->messages()){
          if(($image = $data->upload("image", $upload_dir)) === false){
            $env->erreur("erreur lors de l'envoi de l'image. l'album n'a pas été ajouté");
            return;
          }
          if($image) $source_infos["image"] = $this->user["id"]."/".$image;
          if(
            (
              $id_source = $data->add_source(
                $album["groupes"],
                $album["titre"],
                $this->album_status_id,
                $album["licence"]["id"],
                $album["documents"],
                $album["reference"],
                $album["derivations"],
                $source_infos
              )
            ) === false
          ){
            $env->erreur("Impossible d'ajouter l'album");
            return;
          }
          $env->redirect(
            $env->url("users/albums/edit", array("id" => $id_source)),
            "l'album a été ajouté"
          );
        }
      }
      $env->set_out("groupes", $groupes);
      $env->set_out("licences", $licences);
      $env->set_out("album", $album);
      $env->set_out("source_infos", $source_infos);
      $env->set_out("groupe", $groupe);
    }

    public function edit(){
      $env = $this->env();
      $data = $env->data();
      if(($groupes = $data->groupes($this->user["id"])) === false){
        $env->erreur("Impossible de lire la liste des groupes");
        return;
      }
      if(($licences = $data->licences()) === false){
        $env->erreur("Impossible de lire la liste des licences");
        return;
      }
      if(($sources_access = $data->sources_access()) === false){
        $env->erreur("Impossible de lire les types d'access");
        return;
      }
      if(!($album = $data->source($_GET[$env->param("id")], true))){
        $env->erreur("Impossible de lire les informations de l'album");
        return;
      }
      $album["permissions"] = $data->source_permissions($album, $this->user["id"]);
      if(!$album["permissions"]["editeur"]){
        $env->erreur("vous n'avez pas la permission d'editer cet album");
        return;
      }
      if(!$data->check_user_uploads_dir()){
        $env->erreur("Impossible de creer le repertoire utilisateur");
        return;
      }
      $web_path = $env->path("web");
      $upload_dir = $env->path("content")."uploads/".$this->user["id"];
      $_SESSION["upload_dir"] = $web_path.($web_path ? "" : "/").$env->path("content")."uploads/".$this->user["id"];
      if($_POST){
        $source_infos = array(
          "date_inscription" => $_POST["date_inscription"],
          "ordre" => isset($album["ordre"]) ? $album["ordre"] : 0
        );
        $album = $data->empty_source(
          array(
            "id" => $album["id"],
            "groupes" => $album["groupes"],
            "image" => isset($album["image"]) ? $album["image"] : ""
          )
        );
        $users_sources_mod = $env->get_controller("users/sources");
        if(!($album["titre"] = trim($_POST["titre"]))){
          $env->message("merci de pr&eacute;ciser un titre pour l'album");
        }
        $album["licence"] = array(
          "id" => $_POST["licence"]
        );
        $source_infos["date_creation"] = $_POST["annee_date_creation"]."-".$_POST["mois_date_creation"]."-".$_POST["jour_date_creation"];
        $source_infos["description"] = $_POST["description"];
        foreach($_POST as $post_key => $post_value){
          if(substr($post_key, 0, 13) == "document_nom_"){
            if($id_document = substr($post_key, 13)){
              $album["documents"][$id_document] = array(
                "nom" => $_POST["document_nom_".$id_document],
                "url" => $_POST["document_url_".$id_document]
              );
            }
          }
        }
        if(!$env->messages()){
          if(isset($_POST["del_image"])){
            if($album["image"]){
              if(!@unlink($env->path("content")."uploads/".$album["image"])){
                $env->erreur("Impossible d'effacer l'image");
                return;
              }
            }
            $album["image"] = "";
          }
          else{
            if(($up_image = $data->upload("image", $upload_dir)) === false){
              $env->erreur("Impossible d'uploader l'image");
              return;
            }
            if($up_image) $album["image"] = $this->user["id"]."/".$up_image;
          }
          if($album["image"]) $source_infos["image"] = $album["image"];
          if(
            (
              $data->set_source(
                $album["id"],
                $album["groupes"],
                $album["titre"],
                $this->album_status_id,
                $album["licence"]["id"],
                $album["documents"],
                $album["reference"],
                $album["derivations"],
                $source_infos
              )
            ) === false
          ){
            $env->erreur("Impossible de modifier l'album");
            return;
          }
          $env->redirect(
            $env->url("users/albums/edit", array("id" => $album["id"])),
            "l'album a été modifié"
          );
        }
      }
      $env->set_out("groupes", $groupes);
      $env->set_out("sources_access", $sources_access);
      $env->set_out("licences", $licences);
      $env->set_out("album", $album);
    }

    public function del(){
      $env = $this->env();
      $data = $env->data();
      if(!($album = $data->source($_GET[$env->param("id")], true))){
        $env->erreur("Impossible de lire les informations de l'album");
        return;
      }
      $album["permissions"] = $data->source_permissions($album, $this->user["id"]);
      if(!$album["permissions"]["admin"]){
        $env->erreur("vous n'avez pas la permission d'effacer cet album");
        return;
      }
      if(!$data->del_source($album["id"])){
        $env->erreur("Impossible de supprimer l'album");
        return;
      }
      $env->redirect(
        $env->url("users/albums"),
        "l'album a été supprimé"
      );
    }

    public function groupes(){
      $env = $this->env();
      if(
            !($sources_invitations_controller = $env->get_controller("users/sources_invitations"))
        ||  !$sources_invitations_controller->validate()
      ){
        $env->erreur("impossible de valider le controleur users/sources_invitations");
        return;
      }
      $sources_invitations_controller->source_groupes();
    }

  }
